﻿@page "/weather-detail/create"
@page "/weather-detail/edit/{weatherId:int}"
@inject HttpClient HttpClient
@inject ISnackbar Snackbar
@inject NavigationManager NavigationManager

<PageTitle Title="@title" />
<EditForm Model="@weather" OnValidSubmit="OnValidSubmit">
    @if (!string.IsNullOrEmpty(errorMessage))
    {
        <MudExpansionPanels>
            <MudExpansionPanel Text="エラー" IsExpanded="true">
                <MudText Color="@Color.Error">@errorMessage</MudText>
            </MudExpansionPanel>
        </MudExpansionPanels>
    }
    <DataAnnotationsValidator />
    <MudCard>
        <MudCardContent>
            <MudItem xs="12" sm="6" md="4">
                <PrefectureSelection @bind-SelectedRegionId="weather.Prefecture.RegionId" @bind-SelectedPrefectureId="weather.PrefectureId" />
                <ValidationMessage For="() => weather.PrefectureId"></ValidationMessage>
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudDatePicker Label="日付" Editable="true" @bind-Date="weather.WeatherDate.Value" />
                <ValidationMessage For="() => weather.WeatherDate"></ValidationMessage>
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudNumericField Label="温度" HelperText="整数2桁、少数3桁まで。"
                                 T="decimal?" @bind-Value="weather.Temperature.Value" Immediate Format="F3" For="@(() => weather.Temperature.Value)" />
            </MudItem>
            <MudItem xs="12" sm="6" md="4">
                <MudSelect Label="状態" @bind-Value="weather.Condition.Value" Variant="Variant.Filled">
                    @foreach (var condition in Condition.ToList())
                    {
                        <MudSelectItem Value="@(condition.Value)">@condition.DisplayValue</MudSelectItem>
                    }
                </MudSelect>
            </MudItem>
        </MudCardContent>
        <MudCardActions>
            <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="Color.Primary" Class="mr-4">
                @(weatherId == null || weatherId == 0? "登録":"変更")
            </MudButton>
            <MudButton Link=@($"/weather-list") Variant="Variant.Filled">戻る</MudButton>
        </MudCardActions>
    </MudCard>
</EditForm>

@code {
    [Parameter]
    public int? weatherId { get; set; }

    private string title { get; set; } = "天気情報追加";

    private string errorMessage = string.Empty;

    private WeatherEntity weather = new WeatherEntity()
    {
        WeatherDate = new WeatherDate { Value = DateTime.Today },
        Condition = new Condition(0),
        Prefecture = new PrefectureEntity(),
    };

    protected async override Task OnInitializedAsync()
    {
        if (weatherId != null)
        {
            title = "天気情報編集";
            weather = await HttpClient.GetFromJsonAsync<WeatherEntity>($"api/Weathers/{weatherId.Value}");
        }
    }

    private async Task OnValidSubmit(EditContext context)
    {
        try
        {
            weather.Check();
            errorMessage = string.Empty;

        }
        catch (Exception ex)
        {
            errorMessage = ex.Message;
            return;
        }

        try
        {
            if (weatherId == null)
            {
                await HttpClient.PostAsJsonAsync<WeatherEntity>("api/Weathers", weather);
                Snackbar.Add($"天気情報を追加しました。", Severity.Success);
            }
            else
            {
                await HttpClient.PutAsJsonAsync<WeatherEntity>($"api/Weathers/{weather.WeatherId}", weather);
                Snackbar.Add($"天気編集を編集しました。{weather.Condition.DisplayValue}", Severity.Success);
            }
        }
        catch (Exception ex)
        {
            Snackbar.Add(ex.Message, Severity.Error);
        }
        NavigationManager.NavigateTo("/weather-list");
    }
}